/**
 ** Simple entropy harvester based upon the havege RNG
 **
 ** Copyright 2009-2012 Gary Wuertz gary@issiweb.com
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef HAVEGED_H
#define HAVEGED_H
/**
 * Settings - default values declared in haveged.c
 */
struct pparams  {
   char           *daemon;          /* Daemon name - default is "haveged"           */
   unsigned int   setup;            /* setup options                                */
   unsigned int   ncores;           /* number of cores to use                       */
   unsigned int   buffersz;         /* size of collection buffer (kb)               */
   unsigned int   detached;         /* non-zero if daemonized                       */
   unsigned int   foreground;       /* non-zero if running in foreground            */
   unsigned int   run_level;        /* type of run 0=daemon,1=setup,2=pip,sample kb */
   unsigned int   d_cache;          /* size of data cache (kb)                      */
   unsigned int   i_cache;          /* size of instruction cache (kb)               */
   unsigned int   low_water;        /* write threshold to set - 0 for none          */
   char           *tests_config;    /* online test configuration                    */
   char           *os_rel;          /* path to operating sytem release              */
   char           *pid_file;        /* name of pid file                             */
   char           *poolsize;        /* path to poolsize                             */
   char           *random_device;   /* path to random device                        */
   char           *sample_in;       /* input path for injection diagnostic          */
   char           *sample_out;      /* path to sample file                          */
   unsigned int   verbose;          /* Output level for log or stdout               */
   char           *version;         /* Our version                                  */
   char           *watermark;       /* path to write_wakeup_threshold               */
  };
/**
 * Buffer size used when not running as daemon
 */
#define   APP_BUFF_SIZE 1024
/**
 * Setup options (for app)
 */
#define   RUN_AS_APP    0x001
#define   RANGE_SPEC    0x002
#define   USE_STDOUT    0x004
#define   CAPTURE       0x008
#define   INJECT        0x010
#define   RUN_IN_FG     0x020
#define   SET_LWM       0x040
#define   MULTI_CORE    0x080
#define   TEST_TEST     0x100
/**
 * Default tests settings
 */
#define  TESTS_DEFAULT_APP "ta8b"   /* startup tests                    */
#define  TESTS_DEFAULT_RUN "ta8bcb" /* startup + continuous B           */
/**
 * Testing options
 */
#define  A_CYCLE    0x01ff          /* Procedure A, test5 duty cycle    */
#define  A_WARN     0x0200          /* Only warn of A fails             */
#define  A_RUN      0x0400          /* Run procedure A                  */
#define  A_OPTIONS  0x03ff
#define  B_WARN     0x1000          /* Only warn of B fails             */
#define  B_RUN      0x2000          /* Run proceure B                   */
#define  B_OPTIONS  0x1000

#endif
